﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using C1.Win.C1TrueDBGrid;
using System.Collections;

namespace Sample_ListDataBinding
{
    public partial class GridBindingForm : Form
    {
        public GridBindingForm()
        {
            InitializeComponent();
        
            //Set Default values
            SetCustomerList();
            SetNotifyChangedDataSource();
            SetListDataSource();
            defineReadme();
            cbBinding.SelectedIndex = 0;
        }
       
        #region ***Objects
        //List objects for data binding
        List<Customer> _list;
        BindingList<Customer> _bList;
        BindingList<Customer_Modified> _newbList;
        
        //Array of readme text for the RichTextBox
        string[] readme = new string[3];
        #endregion

        #region ***Methods

        //Creating a List of Customers
        public void SetListDataSource()
        {
            _list = new List<Customer>();
            _list.Add(new Customer(1, "Trevors & Trevors Co Ltd", "Washington","(206) 555-8257"));
            _list.Add(new Customer(2, "Alfreds Futterkiste", "Germany", "030-0074321"));
            _list.Add(new Customer(3, "Ana Trujillo Emparedados y helados", "Mexico", "(5) 555-4729"));
            _list.Add(new Customer(4, "Bon app'", "Paris", "91.24.45.40"));
            _list.Add(new Customer(5, "Drachenblut Delikatessen", "Germany", "0241-039123"));
            _list.Add(new Customer(6, "Du monde entier", "Paris", "40.67.88.88"));
            _list.Add(new Customer(7, "Frankenversand", "Germany", "089-0877310"));
            _list.Add(new Customer(8, "Lazy K Kountry Store", "Washington","(509) 555-7969"));
            _list.Add(new Customer(9, "Lehmanns Marktstand", "Germany", "069-0245984"));
            _list.Add(new Customer(10, "Let's Stop N Shop", "Washington","(206) 555-4112"));
            _list.Add(new Customer(11, "Pericles Comidas clásicas", "Mexico", "(5) 552-3745"));
        }

        //Creating a Binding List of Customers
        public void SetCustomerList()
        {
            _bList = new BindingList<Customer>();
            _bList.Add(new Customer(1, "Trevors & Trevors Co Ltd", "Washington", "(206) 555-8257"));
            _bList.Add(new Customer(2, "Alfreds Futterkiste", "Germany", "030-0074321"));
            _bList.Add(new Customer(3, "Ana Trujillo Emparedados y helados", "Mexico", "030-0074321"));
            _bList.Add(new Customer(4, "Bon app'", "Paris", "91.24.45.40"));
            _bList.Add(new Customer(5, "Drachenblut Delikatessen", "Germany", "0241-039123"));
            _bList.Add(new Customer(6, "Du monde entier", "Paris", "40.67.88.88"));
            _bList.Add(new Customer(7, "Frankenversand", "Germany", "089-0877310"));
            _bList.Add(new Customer(8, "Lazy K Kountry Store", "Washington", "(509) 555-7969"));
            _bList.Add(new Customer(9, "Lehmanns Marktstand", "Germany", "069-0245984"));
            _bList.Add(new Customer(10, "Let's Stop N Shop", "Washington", "(206) 555-4112"));
            _bList.Add(new Customer(11, "Pericles Comidas clásicas", "Mexico", "(5) 552-3745"));
        }

        //Creating a Binding List of Customers implementing INotifyChanged event
        public void SetNotifyChangedDataSource()
        {
            _newbList = new BindingList<Customer_Modified>();
            _newbList.Add(new Customer_Modified(1, "Trevors & Trevors Co Ltd", "Washington", "(206) 555-8257"));
            _newbList.Add(new Customer_Modified(2, "Alfreds Futterkiste", "Germany", "030-0074321"));
            _newbList.Add(new Customer_Modified(3, "Ana Trujillo Emparedados y helados", "Mexico", "030-0074321"));
            _newbList.Add(new Customer_Modified(4, "Bon app'", "Paris", "91.24.45.40"));
            _newbList.Add(new Customer_Modified(5, "Drachenblut Delikatessen", "Germany", "0241-039123"));
            _newbList.Add(new Customer_Modified(6, "Du monde entier", "Paris", "40.67.88.88"));
            _newbList.Add(new Customer_Modified(7, "Frankenversand", "Germany", "089-0877310"));
            _newbList.Add(new Customer_Modified(8, "Lazy K Kountry Store", "Washington", "(509) 555-7969"));
            _newbList.Add(new Customer_Modified(9, "Lehmanns Marktstand", "Germany", "069-0245984"));
            _newbList.Add(new Customer_Modified(10, "Let's Stop N Shop", "Washington", "(206) 555-4112"));
            _newbList.Add(new Customer_Modified(11, "Pericles Comidas clásicas", "Mexico", "(5) 552-3745"));
        }

        //Defining the readme text
        void defineReadme()
        {
            readme[0] = "Binding With List<> Collection \n\n" +
                "When the C1TrueDbGrid is bound to the List<> collection : \n\n" +
                "1. New added row is not shown. If C1TrueDbgrid1.AllowAddRow is set to True, then newly added row is shown in the new row. But thereafter, new rows are not displayed on the grid. User needs to rebind the data to view the newly added row.\n\n" +
                "2. When any field is changed in the list collection, the changes are not shown in the UI. User needs to refresh the grid by setting other property or by clicking the grid.";
            
            readme[1] = "Binding With BindingList<> Collection \n\n" +
                "When the C1TrueDbGrid is bound to the BindingList<> collection : \n\n" +
                "1. New added row are immediately shown on the grid. \n\n" +
                "2. When any field is changed in the list collection, the changes are not shown in the UI. User needs to refresh the grid by setting other property or by clicking the grid.";

            readme[2] = "Binding With BindingList<> Collection implementing INotifyPropertyChanged \n\n" +
                "When the C1TrueDbGrid is bound to the BindingList<> collection implementing INotifyPropertyChanged interface : \n\n" + 
                "1. New added row are immediately shown on the grid. \n\n" +
                "2. Any changed in the collection are shown on the grid UI. No need to refresh the grid.";
        }

        #endregion

        #region ***Events
        //Changing data source on ComboBox SelectedIndexChanged event
        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            switch (cbBinding.SelectedIndex)
            {
                case 0 :
                    c1TrueDBGrid1.DataSource = _list;
                    c1TrueDBGrid1.Caption = "Binding to List<> collection";
                    rtbReadMe.Text = readme[0];
                    break;
                case 1 :
                    c1TrueDBGrid1.DataSource = _bList;
                    c1TrueDBGrid1.Caption = "Binding to BindingList<> collection";
                    rtbReadMe.Text = readme[1];
                    break;
                case 2 :
                    c1TrueDBGrid1.DataSource = _newbList;
                    c1TrueDBGrid1.Caption = "Binding to BindingList<> collection implementing INotifyPropertyChanged";
                    rtbReadMe.Text = readme[2];
                    break;
            }
        }

        //Add new object to the list
        private void btnAdd_Click(object sender, EventArgs e)
        {
            switch (cbBinding.SelectedIndex)
            {
                case 0:
                    int id1 = _list[_list.Count - 1].CustomerId + 1;
                    Customer cst1 = new Customer(id1, "Tortuga Restaurante", "Mexico", "(5) 555-2933");
                    _list.Add(cst1);
                    break;
                case 1:
                    int id2 = _bList[_bList.Count - 1].CustomerId + 1;
                    Customer cst2 = new Customer(id2, "Tortuga Restaurante", "Mexico", "(5) 555-2933");
                    _bList.Add(cst2);
                    break;
                case 2 :
                    int id3 = _newbList[_newbList.Count - 1].CustomerId + 1;
                    Customer_Modified cst3 = new Customer_Modified(id3, "Tortuga Restaurante", "Mexico","(5) 555-2933");;
                    _newbList.Add(cst3);
                    break;
            }
        }

        //Editing Region of third row in list
        private void btnEdit_Click(object sender, EventArgs e)
        {
            switch (cbBinding.SelectedIndex)
            {
                case 0:
                    _list[2].CustomerId= _list[2].CustomerId +10;
                    _list[2].CompanyName = "ComponentOne";
                    _list[2].Region = "Pittsburgh";
                    _list[2].Phone = "1.800.858.2739";
                    break;
                case 1:
                     _bList[2].CustomerId= _bList[2].CustomerId +10;
                    _bList[2].CompanyName = "ComponentOne";
                    _bList[2].Region = "Pittsburgh";
                    _bList[2].Phone = "1.800.858.2739";
                    break;
                case 2:
                     _newbList[2].CustomerId= _newbList[2].CustomerId +10;
                    _newbList[2].CompanyName = "ComponentOne";
                    _newbList[2].Region = "Pittsburgh";
                    _newbList[2].Phone = "1.800.858.2739";
                    break;
            }
        }
        #endregion
    }
}
